# PhasicFlow: generalBoundary Class Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

generalBoundary Class Reference
Inheritance diagram for generalBoundary:
[legend]
Collaboration diagram for generalBoundary:
[legend]

## Public Member Functions

| TypeInfo ("generalBoundary")
| generalBoundary (const boundaryBase &boundary, const pointStructure &pStruct, const word &dataType, const word &option)
| ~generalBoundary () override=default
uint32 | thisBoundaryIndex () const
uint32 | mirrorBoundaryindex () const
auto | size () const
auto | capacity () const
auto | neighborProcSize () const
int | neighborProcessorNo () const
int | thisProcessorNo () const
const auto & | boundary () const
const auto & | indexList () const
const auto & | mirrorBoundary () const
const word & | boundaryName () const
const word & | type () const
const auto & | pStruct () const
bool | isBoundaryMaster () const
const Time & | time () const
Public Member Functions inherited from observer
| observer (message msg)
| observer (const subscriber *subscrbr, message msg)
virtual | ~observer ()
void | subscribe (const subscriber *subscrbr, message msg)
observer & | addEvent (message::EVENT event)
bool | subscribed () const
void | addToSubscriber (const subscriber *subscrbr, message msg)
bool | addToSubscriber (const subscriber &subscriber)
virtual bool | hearChanges (real t, real dt, uint32 iter, const message &msg, const anyList &varList)=0

## Private Attributes

const boundaryBase & | boundary_
const pointStructure & | pStruct_
const bool | isBoundaryMaster_

## Static Private Attributes

static const message | defaultMessage_ {message::BNDR_RESET}

## Additional Inherited Members

Static Public Member Functions inherited from observer
static constexpr auto | numEvents ()

## Detailed Description

Definition at line 38 of file generalBoundary.hpp.

## Constructor & Destructor Documentation

## generalBoundary()

generalBoundary | ( | const boundaryBase & | boundary,
|  | const pointStructure & | pStruct,
|  | const word & | dataType,
|  | const word & | option
| ) |  |

Definition at line 25 of file generalBoundary.cpp.

## ~generalBoundary()

~generalBoundary | ( |  | ) |

overridedefault

## Member Function Documentation

## TypeInfo()

TypeInfo | ( | "generalBoundary" |  | ) |

## thisBoundaryIndex()

uint32 thisBoundaryIndex | ( |  | ) | const

inline

Definition at line 66 of file generalBoundary.hpp.

References generalBoundary::boundary_, and boundaryBase::thisBoundaryIndex().

Here is the call graph for this function:

## mirrorBoundaryindex()

uint32 mirrorBoundaryindex | ( |  | ) | const

inline

Definition at line 72 of file generalBoundary.hpp.

References generalBoundary::boundary_, and boundaryBase::mirrorBoundaryIndex().

Here is the call graph for this function:

## size()

auto size | ( |  | ) | const

inline

Definition at line 78 of file generalBoundary.hpp.

References generalBoundary::boundary_, and boundaryBase::size().

Referenced by boundaryField< T, void >::mirrorField(), and boundaryField< T, void >::thisField().

Here is the call graph for this function:
Here is the caller graph for this function:

## capacity()

auto capacity | ( |  | ) | const

inline

Definition at line 84 of file generalBoundary.hpp.

References generalBoundary::boundary_, and boundaryBase::capacity().

Here is the call graph for this function:

## neighborProcSize()

auto neighborProcSize | ( |  | ) | const

inline

Definition at line 90 of file generalBoundary.hpp.

References generalBoundary::boundary_, and boundaryBase::neighborProcSize().

Here is the call graph for this function:

## neighborProcessorNo()

int neighborProcessorNo | ( |  | ) | const

inline

Definition at line 96 of file generalBoundary.hpp.

References generalBoundary::boundary_, and boundaryBase::neighborProcessorNo().

Here is the call graph for this function:

## thisProcessorNo()

int thisProcessorNo | ( |  | ) | const

inline

Definition at line 102 of file generalBoundary.hpp.

References generalBoundary::boundary_, and boundaryBase::thisProcessorNo().

Here is the call graph for this function:

## boundary()

const auto& boundary | ( |  | ) | const

inline

Definition at line 108 of file generalBoundary.hpp.

References generalBoundary::boundary_.

Referenced by periodicBoundaryGrainInteraction< contactForceModel, geometryMotionModel >::periodicBoundaryGrainInteraction(), periodicBoundarySphereInteraction< contactForceModel, geometryMotionModel >::periodicBoundarySphereInteraction(), and boundaryField< T, void >::thisField().

Here is the caller graph for this function:

## indexList()

const auto& indexList | ( |  | ) | const

inline

Definition at line 114 of file generalBoundary.hpp.

References generalBoundary::boundary_, and boundaryBase::indexList().

Referenced by boundaryField< T, void >::mirrorField(), and boundaryField< T, void >::thisField().

Here is the call graph for this function:
Here is the caller graph for this function:

## mirrorBoundary()

const auto& mirrorBoundary | ( |  | ) | const

inline

Definition at line 120 of file generalBoundary.hpp.

References generalBoundary::boundary_, and boundaryBase::mirrorBoundary().

Referenced by boundaryField< T, void >::mirrorField().

Here is the call graph for this function:
Here is the caller graph for this function:

## boundaryName()

const word& boundaryName | ( |  | ) | const

inline

Definition at line 126 of file generalBoundary.hpp.

References generalBoundary::boundary_, and boundaryBase::name().

Referenced by boundaryGrainInteraction< contactForceModel, geometryMotionModel >::hearChanges(), boundarySphereInteraction< contactForceModel, geometryMotionModel >::hearChanges(), and boundaryField< T, void >::name().

Here is the call graph for this function:
Here is the caller graph for this function:

## type()

const word& type | ( |  | ) | const

inline

Definition at line 132 of file generalBoundary.hpp.

References generalBoundary::boundary_, and boundaryBase::type().

Referenced by boundaryGrainInteraction< contactForceModel, geometryMotionModel >::hearChanges(), and boundarySphereInteraction< contactForceModel, geometryMotionModel >::hearChanges().

Here is the call graph for this function:
Here is the caller graph for this function:

## pStruct()

const auto& pStruct | ( |  | ) | const

inline

Definition at line 138 of file generalBoundary.hpp.

References generalBoundary::pStruct_.

Referenced by periodicBoundaryContactSearch::setSearchBox().

Here is the caller graph for this function:

## isBoundaryMaster()

bool isBoundaryMaster | ( |  | ) | const

inline

Definition at line 144 of file generalBoundary.hpp.

References generalBoundary::isBoundaryMaster_.

## time()

pFlow::Time const & time | ( |  | ) | const

Definition at line 39 of file generalBoundary.cpp.

References generalBoundary::pStruct_, and pointStructure::time().

Here is the call graph for this function:

## Member Data Documentation

## boundary_

const boundaryBase& boundary_

private

Definition at line 44 of file generalBoundary.hpp.

Referenced by generalBoundary::boundary(), generalBoundary::boundaryName(), generalBoundary::capacity(), generalBoundary::indexList(), generalBoundary::mirrorBoundary(), generalBoundary::mirrorBoundaryindex(), generalBoundary::neighborProcessorNo(), generalBoundary::neighborProcSize(), generalBoundary::size(), generalBoundary::thisBoundaryIndex(), generalBoundary::thisProcessorNo(), and generalBoundary::type().

## pStruct_

const pointStructure& pStruct_

private

Definition at line 46 of file generalBoundary.hpp.

Referenced by generalBoundary::pStruct(), and generalBoundary::time().

## isBoundaryMaster_

const bool isBoundaryMaster_

private

Definition at line 48 of file generalBoundary.hpp.

Referenced by generalBoundary::isBoundaryMaster().

## defaultMessage_

const message defaultMessage_ {message::BNDR_RESET}

inlinestaticprivate

Definition at line 51 of file generalBoundary.hpp.

The documentation for this class was generated from the following files:

- src/phasicFlow/containers/pointField/boundaryField/generalBoundary/generalBoundary.hpp
- src/phasicFlow/containers/pointField/boundaryField/generalBoundary/generalBoundary.cpp